//  Ghalya Alsanea
//  uses a pulse and breath sensor from ardiuno to send to p5.js

int pulsePin = A0;  // Pulse Sensor PURPLE WIRE connected to ANALOG PIN 0
int pulse;          // holds the incoming pulse sensor raw data ranging 0-1024

int breathPin = A1; //breath sensor pin
int breath;         // holds the incoming breath sensor raw data ranging 0-1024

//for callibrations
int minB = 1028;
int maxB = 0;
int minP = 1028;
int maxP = 0;
int readings;

void setup() {
   Serial.begin(9600);
}

void loop() {
    //read pulse data
    pulse = analogRead(pulsePin);
    //find the general range of the raw pulse data to properly map it
    if (pulse < minP){
        minP = pulse;
    }
    if (pulse > maxP){
        maxP = pulse;
    }

    //read breath data
    breath = analogRead(breathPin);
    //find the general range of the raw data to properly map it
    if (breath < minB){
        minB = breath;
    }
    if (breath > maxB){
        maxB = breath;
    }
        
    //start sending data only after callibration has happenned
    if (readings > 20){
        //map the raw data between 0 and 255 so it can be sent as one byte to the p5.js Serial
        int breathSend = map(breath, minB, maxB, 0, 255);
        int pulseSend = map(pulse, minP, maxP, 0, 255);
        Serial.write(breathSend);
        Serial.write(pulseSend);
    }

    readings++;
    delay(100);

//    //for testing
//    Serial.print("RAW ");
//    Serial.print(breath);
//    Serial.print(",   min: ");
//    Serial.print(minB);
//    Serial.print(",   max: ");
//    Serial.println(maxB);
}
